export default class SgFormsPdf {
	static PDF_DOWNLOAD_BUTTON_SELECTOR = '.sg-forms-pdf-download';

	/**
	 * initialize variables
	 *
	 * @param {Element} _root
	 */
	constructor(_root) {
		this.root = _root;

		if (!this.root) {
			return;
		}

		this.pdfDownloadButton = this.root.querySelector(SgFormsPdf.PDF_DOWNLOAD_BUTTON_SELECTOR);

		if (!this.pdfDownloadButton) {
			return;
		}

		this.tempPdfFile = this.pdfDownloadButton.getAttribute('data-tempfile');
		this.buttonLabel = this.pdfDownloadButton.getAttribute('data-label');

		this._setupEventListeners();
	}

	/**
	 * set up event listeners
	 *
	 * @private
	 */
	_setupEventListeners() {
		this.pdfDownloadButton.addEventListener('click', (event) => {
			this.onPdfDownloadButtonClick(event);
		});
	}

	/**
	 *
	 * opens the linked pdf file, disables the button and updates the button label
	 *
	 * @param {Event} event
	 */
	onPdfDownloadButtonClick(event) {
		event.preventDefault();
		if (this.pdfDownloadButton.disabled) {
			return;
		}
		this.pdfDownloadButton.disabled = true;
		this.pdfDownloadButton.innerText = this.buttonLabel;
		window.open(`/index.php?eID=pdfform&file=${this.tempPdfFile}`, '_blank');
	}
}
